package DataDecoder;
# (C) 2005 XDA Developers  itsme@xs4all.nl

my $keytable;
INIT {
    $keytable= pack("C*", 
        0xA3, 0xC9, 0x84, 0x3C, 0x0A, 0xB3, 0xA9, 0x63, 
        0x15, 0x52, 0xCE, 0x33, 0x29, 0xC8, 0x99, 0x88, 
        0x43, 0x6A, 0x1F, 0xF8, 0x32, 0x21, 0xB1, 0x59, 
        0x04, 0x0F, 0xF9, 0x83, 0xBE, 0x76, 0x47, 0x57, 
        0x50, 0xD6, 0x25, 0x01, 0xC7, 0x56, 0x31, 0x79, 
        0xC5, 0x65, 0x2C, 0x50, 0x2E, 0xA1, 0x4E, 0xA9, 
        0x25, 0xF8, 0xDC, 0x86, 0x37, 0x0D, 0xFD, 0x45, 
        0xD5, 0xDD, 0xCA, 0x6A, 0x08, 0xA2, 0xA4, 0x9E, 
        0x60, 0xF8, 0xCA, 0xF8, 0x2E, 0x3E, 0x2A, 0x7C, 
        0xF2, 0x3F, 0x78, 0xE1, 0x17, 0x11, 0x7E, 0x98, 
        0xDE, 0x3E, 0xB3, 0x09, 0x99, 0x22, 0x0E, 0x20, 
        0x19, 0x94, 0x1C, 0x08, 0x69, 0xC9, 0x51, 0x36, 
        0xBD, 0x74, 0x9C, 0xAA, 0xA5, 0x32, 0x3D, 0x71, 
        0x86, 0x26, 0xDB, 0x6F, 0x4B, 0xE0, 0xD1, 0x5B, 
        0x58, 0x84, 0xCA, 0x0B, 0xBF, 0x28, 0x8D, 0xF2, 
        0xB7, 0x7D, 0x1A, 0xE7, 0x4A, 0xB2, 0xF5, 0x27, 
        0x4D, 0x95, 0xC2, 0x9E, 0x95, 0xFC, 0x12, 0x62, 
        0x68, 0x63, 0x7D, 0x81, 0x32, 0xD6, 0xF1, 0xFC, 
        0x79, 0x12, 0x49, 0x13, 0x13, 0xE7, 0x21, 0xC3, 
        0x97, 0xE0, 0xE9, 0x8E, 0x11, 0x26, 0x39, 0x7A, 
        0xFA, 0xA2, 0x64, 0x5C, 0x67, 0x62, 0x50, 0x56, 
        0x80, 0x3E, 0x85, 0x9F, 0x34, 0xBB, 0x83, 0x82, 
        0x2B, 0x2F, 0x59, 0xAA, 0xFC, 0x26, 0x73, 0x9C, 
        0xA1, 0x05, 0xB4, 0x85, 0x28, 0xED, 0xC5, 0x36, 
        0xAA, 0xE2, 0xAC, 0x6D, 0x81, 0x2D, 0xA0, 0x56, 
        0xB6, 0xFE, 0x1B, 0x51, 0xB9, 0x56, 0x32, 0xF6, 
        0x55, 0x24, 0x22, 0x56, 0xE2, 0xAF, 0x2B, 0x84, 
        0xBD, 0x33, 0xA1, 0x55, 0xF5, 0xCF, 0x40, 0x63, 
        0x47, 0x9E, 0xC0, 0x58, 0x4D, 0x25, 0xA9, 0x69, 
        0xF2, 0xED, 0x69, 0x20, 0x29, 0x70, 0xA3, 0x5F, 
        0xDF, 0x3A, 0xCB, 0xA2, 0x2D, 0x48, 0xF0, 0x84, 
        0xD3, 0xB4, 0xD8, 0x85, 0xE2, 0x94, 0x52, 0x0A, 
        0xB8, 0x1F, 0xC8, 0xA5, 0x31, 0x11, 0x14, 0x97, 
        0x1C, 0x51, 0x94, 0x93, 0xEC, 0xD1, 0x81, 0xC5, 
        0xB0, 0xB6, 0x7C, 0x13, 0x46, 0xBA, 0x6A, 0xA3, 
        0xCB, 0xCE, 0x82, 0x9D, 0x55, 0x03, 0xA4, 0x32, 
        0xE5, 0xAA, 0xED, 0xDD, 0x97, 0xBA, 0x88, 0xE8, 
        0x1C, 0x73, 0xC7, 0x33, 0x6A, 0x41, 0x72, 0x31, 
        0xB2, 0xE3, 0x5F, 0x33, 0x93, 0xCC, 0x42, 0xE9, 
        0x8D, 0xCA, 0xC7, 0x25, 0xB8, 0xE5, 0xDE, 0xE3, 
        0xB6, 0x8A, 0x56, 0x87, 0xE6, 0xE9, 0xAE, 0x65, 
        0xDA, 0x9B, 0x28, 0x86, 0x0C, 0x88, 0x1E, 0xA9, 
        0xCC, 0x08, 0x99, 0x89, 0x7D, 0x48, 0x20, 0x5E, 
        0x01, 0xF0, 0xCE, 0xA6, 0x72, 0x02, 0xA8, 0x25, 
        0x13, 0x05, 0x2D, 0x2B, 0x86, 0x64, 0x2E, 0x15, 
        0x3F, 0x11, 0xDF, 0x16, 0x38, 0x6D, 0x2F, 0x38, 
        0xE6, 0x6C, 0x55, 0x9D, 0x6D, 0xF4, 0xAB, 0x0B
    );
}

# 1)   while(len--) *p++ -= i++
# 2) xor's chunk of data with:  { crc[data+4,len-4], keytable }

# enc = a0,a1,a2,a3,a4,...
#   c = crc(a4, ...)
# sub = a0-0, a1-1, a2-2, a3-3, a4-4, ...
# dec = (a0-0)^c0, (a1-1)^c1, (a2-2)^c2, (a3-3)^c3, (a4-4)^t0, ...
sub decodedatachunk {
    my ($encdata, $index)= @_;

    my $decdata;

    my @bytes = unpack("C*", $encdata);
    my $subdata = pack("C*", map { ($bytes[$_]-$_)&0xff } (0..$#bytes));
    if (length($encdata)>4) {
        my $crc= CrcCalc::crc32(substr($encdata,4), $index);

        $decdata= $subdata ^ substr(pack("Va*", $crc, $keytable),0,length($subdata));
    }
    else {
        $decdata= $subdata ^ substr($keytable,0,length($subdata));
    }
    return $decdata;
}
# dec= d0,d1,d2,d3,d4,...
# sub=  0, 0, 0, 0,d4^t0, ...
# enc= d0^c0+0, d1^c1+1, d2^c2+2, d3^c3+3, d4^t0+4, ...
#  c= crc(d4^t0+4, ...)
sub encodedatachunk {
    my ($decdata, $index)= @_;

    my $subdata;
    if (length($decdata)>4) {
        $subdata= $decdata ^ substr(pack("Va*", 0, $keytable),0,length($decdata));
    }
    else {
        $subdata= $decdata ^ substr($keytable,0,length($decdata));
    }
    my @bytes = unpack("C*", $subdata);
    my $encdata= pack("C*", map { ($bytes[$_]+$_)&0xff } (4..$#bytes));

    if (length($decdata)>4) {
        my $crc= CrcCalc::crc32(substr($encdata,0), $index);

        my @crcb= unpack("C*", pack("V", $crc)^substr($decdata,0,4));
        my $enccrc= pack("C*", map { ($crcb[$_]+$_)&0xff } (0..3));

        $encdata = $enccrc.$encdata;
    }
    return $encdata;
}

package CrcSumCalc; 
use integer;
sub checksum {
    my ($data, $blocksize, $init)= @_;

    my $sum= 0;

    for (my $ofs= 0 ; $ofs < length($data) ; $ofs += $blocksize)
    {
        $sum += CrcCalc::crc32(substr($data, $ofs, $blocksize), $init);
    }
    return $sum;
}
package CrcCalc; 
use integer;
my @crc32tab;

INIT {
    initcrc(0xEDB88320);
#   for (my $i=0 ; $i<256 ; $i++) {
#       printf("%08lx%s", $crc32tab[$i], ($i%7)==7?"\n":", ");
#   }
}
sub calccrc32tab {
    my ($c, $crcBase)= @_;
    my $val = $c;
    for (my $i=0 ; $i<8 ; $i++)
    {
      $val = (($val>>1)&0x7fffffff)^ ( ($val&1)?$crcBase:0 );
    }
    return $val;
}

sub initcrc {
    my ($crcBase)= @_;
    my $val;
    for (my $i=0 ; $i<256 ; $i++)
    {
        $val = calccrc32tab($i, $crcBase);
        $crc32tab[$i]=$val;
    }
}

sub crc32byte {
    my ($c, $crc)= @_;
    return (($crc>>8)&0xffffff) ^ $crc32tab[($crc^ord($c))&0xff];
}

sub crc32 {
    my ($data, $crc)= @_;
    $crc ||= 0;

    for (my $i=0 ; $i<length($data) ; $i++) {
        $crc= crc32byte(substr($data,$i,1),$crc);
    }
    return $crc;
}

sub crc32_4 {
    my ($data, $crc)= @_;
    $crc ||= 0;

    for (my $i=0 ; $i<length($data) ; $i+=4) {
        $crc= crc32byte(substr($data,$i,1),$crc);
    }
    return $crc;
}



